clarify license of test scripts
[oweals/gnunet.git] / src / gns / test_gns_rel_expiration.sh
1 #!/bin/bash
2 # This file is in the public domain.
3 trap "gnunet-arm -e -c test_gns_lookup.conf" SIGINT
4
5 LOCATION=$(which gnunet-config)
6 if [ -z $LOCATION ]
7 then
8   LOCATION="gnunet-config"
9 fi
10 $LOCATION --version 1> /dev/null
11 if test $? != 0
12 then
13         echo "GNUnet command line tools cannot be found, check environmental variables PATH and GNUNET_PREFIX"
14         exit 77
15 fi
16
17 MY_EGO="myego"
18 OTHER_EGO="delegatedego"
19
20 rm -rf `gnunet-config -c test_gns_lookup.conf -f -s paths -o GNUNET_TEST_HOME`
21 which timeout &> /dev/null && DO_TIMEOUT="timeout 5"
22 TEST_IP="127.0.0.1"
23 gnunet-arm -s -c test_gns_lookup.conf
24 gnunet-identity -C $MY_EGO -c test_gns_lookup.conf
25 gnunet-identity -C $OTHER_EGO -c test_gns_lookup.conf
26 DELEGATED_PKEY=$(gnunet-identity -d -c test_gns_lookup.conf | grep $OTHER_EGO | awk '{print $3}')
27 gnunet-namestore -p -z $MY_EGO -a -n b -t PKEY -V $DELEGATED_PKEY -e never -c test_gns_lookup.conf
28 gnunet-namestore -p -z $OTHER_EGO -a -n www -t A -V $TEST_IP -e '5 s' -c test_gns_lookup.conf
29 gnunet-arm -i gns -c test_gns_lookup.conf
30 # confirm that lookup currently works
31 RES_IP=`$DO_TIMEOUT gnunet-gns --raw -u www.b.$MY_EGO -t A -c test_gns_lookup.conf`
32 # remove entry
33 gnunet-namestore -z $OTHER_EGO -d -n www -t A -V $TEST_IP  -e '5 s' -c test_gns_lookup.conf
34 # wait for old entry with 5s 'expiration' to definitively expire
35 sleep 6
36 # try again, should no longer work
37 RES_IP_EXP=`$DO_TIMEOUT gnunet-gns --raw -u www.b.$MY_EGO -t A -c test_gns_lookup.conf`
38 gnunet-namestore -z $MY_EGO -d -n b -t PKEY -V $DELEGATED_PKEY  -e never -c test_gns_lookup.conf
39 gnunet-identity -D $MY_EGO -c test_gns_lookup.conf
40 gnunet-identity -D $OTHER_EGO -c test_gns_lookup.conf
41 gnunet-arm -e -c test_gns_lookup.conf
42 rm -rf `gnunet-config -c test_gns_lookup.conf -f -s paths -o GNUNET_TEST_HOME`
43
44 if [ "$RES_IP_EXP" == "$TEST_IP" ]
45 then
46   echo "Failed to properly expire IP, got $RES_IP_EXP."
47   exit 1
48 fi
49
50 if [ "$RES_IP" == "$TEST_IP" ]
51 then
52   exit 0
53 else
54   echo "Failed to properly resolve IP, got $RES_IP."
55   exit 1
56 fi